// @generated by protobuf-ts 2.9.1
// @generated from protobuf file "services.proto" (package "proxy", syntax proto3)
// tslint:disable
import { Auth } from "./services";
import type { ValidateTokenResponse } from "./messages";
import type { ValidateTokenRequest } from "./messages";
import type { RpcTransport } from "@protobuf-ts/runtime-rpc";
import type { ServiceInfo } from "@protobuf-ts/runtime-rpc";
import { ApiServices } from "./services";
import type { ProxyInfoResponse } from "./api";
import type { SuspendServerRequest } from "./api";
import type { Server } from "./messages";
import type { RemoveServerRequest } from "./api";
import type { RemoveBackendRequest } from "./api";
import type { RemoveRoutingRequest } from "./api";
import type { Backend } from "./messages";
import type { GetServerResponse } from "./api";
import type { GetBackendResponse } from "./api";
import type { GetRoutingResponse } from "./api";
import type { Routing } from "./messages";
import type { RemoveListenerRequest } from "./api";
import type { Listener } from "./messages";
import { stackIntercept } from "@protobuf-ts/runtime-rpc";
import type { GetListenerResponse } from "./api";
import type { Empty } from "./google/protobuf/empty";
import type { UnaryCall } from "@protobuf-ts/runtime-rpc";
import type { RpcOptions } from "@protobuf-ts/runtime-rpc";
/**
 * @generated from protobuf service proxy.ApiServices
 */
export interface IApiServicesClient {
    /**
     * @generated from protobuf rpc: GetListener(google.protobuf.Empty) returns (proxy.GetListenerResponse);
     */
    getListener(input: Empty, options?: RpcOptions): UnaryCall<Empty, GetListenerResponse>;
    /**
     * @generated from protobuf rpc: AddListener(proxy.Listener) returns (google.protobuf.Empty);
     */
    addListener(input: Listener, options?: RpcOptions): UnaryCall<Listener, Empty>;
    /**
     * @generated from protobuf rpc: RemoveListener(proxy.RemoveListenerRequest) returns (google.protobuf.Empty);
     */
    removeListener(input: RemoveListenerRequest, options?: RpcOptions): UnaryCall<RemoveListenerRequest, Empty>;
    /**
     * @generated from protobuf rpc: AddRouting(proxy.Routing) returns (google.protobuf.Empty);
     */
    addRouting(input: Routing, options?: RpcOptions): UnaryCall<Routing, Empty>;
    /**
     * @generated from protobuf rpc: GetRouting(google.protobuf.Empty) returns (proxy.GetRoutingResponse);
     */
    getRouting(input: Empty, options?: RpcOptions): UnaryCall<Empty, GetRoutingResponse>;
    /**
     * @generated from protobuf rpc: GetBackend(google.protobuf.Empty) returns (proxy.GetBackendResponse);
     */
    getBackend(input: Empty, options?: RpcOptions): UnaryCall<Empty, GetBackendResponse>;
    /**
     * @generated from protobuf rpc: GetServer(google.protobuf.Empty) returns (proxy.GetServerResponse);
     */
    getServer(input: Empty, options?: RpcOptions): UnaryCall<Empty, GetServerResponse>;
    /**
     * @generated from protobuf rpc: AddBackend(proxy.Backend) returns (google.protobuf.Empty);
     */
    addBackend(input: Backend, options?: RpcOptions): UnaryCall<Backend, Empty>;
    /**
     * @generated from protobuf rpc: RemoveRouting(proxy.RemoveRoutingRequest) returns (google.protobuf.Empty);
     */
    removeRouting(input: RemoveRoutingRequest, options?: RpcOptions): UnaryCall<RemoveRoutingRequest, Empty>;
    /**
     * @generated from protobuf rpc: RemoveBackend(proxy.RemoveBackendRequest) returns (google.protobuf.Empty);
     */
    removeBackend(input: RemoveBackendRequest, options?: RpcOptions): UnaryCall<RemoveBackendRequest, Empty>;
    /**
     * @generated from protobuf rpc: RemoveServer(proxy.RemoveServerRequest) returns (google.protobuf.Empty);
     */
    removeServer(input: RemoveServerRequest, options?: RpcOptions): UnaryCall<RemoveServerRequest, Empty>;
    /**
     * @generated from protobuf rpc: AddServer(proxy.Server) returns (google.protobuf.Empty);
     */
    addServer(input: Server, options?: RpcOptions): UnaryCall<Server, Empty>;
    /**
     * @generated from protobuf rpc: RemoveAllListener(google.protobuf.Empty) returns (google.protobuf.Empty);
     */
    removeAllListener(input: Empty, options?: RpcOptions): UnaryCall<Empty, Empty>;
    /**
     * @generated from protobuf rpc: RemoveAllRouting(google.protobuf.Empty) returns (google.protobuf.Empty);
     */
    removeAllRouting(input: Empty, options?: RpcOptions): UnaryCall<Empty, Empty>;
    /**
     * @generated from protobuf rpc: RemoveAllBackend(google.protobuf.Empty) returns (google.protobuf.Empty);
     */
    removeAllBackend(input: Empty, options?: RpcOptions): UnaryCall<Empty, Empty>;
    /**
     * @generated from protobuf rpc: RemoveAllServer(google.protobuf.Empty) returns (google.protobuf.Empty);
     */
    removeAllServer(input: Empty, options?: RpcOptions): UnaryCall<Empty, Empty>;
    /**
     * @generated from protobuf rpc: SuspendServer(proxy.SuspendServerRequest) returns (google.protobuf.Empty);
     */
    suspendServer(input: SuspendServerRequest, options?: RpcOptions): UnaryCall<SuspendServerRequest, Empty>;
    /**
     * @generated from protobuf rpc: ProxyInfo(google.protobuf.Empty) returns (proxy.ProxyInfoResponse);
     */
    proxyInfo(input: Empty, options?: RpcOptions): UnaryCall<Empty, ProxyInfoResponse>;
}
/**
 * @generated from protobuf service proxy.ApiServices
 */
export class ApiServicesClient implements IApiServicesClient, ServiceInfo {
    typeName = ApiServices.typeName;
    methods = ApiServices.methods;
    options = ApiServices.options;
    constructor(private readonly _transport: RpcTransport) {
    }
    /**
     * @generated from protobuf rpc: GetListener(google.protobuf.Empty) returns (proxy.GetListenerResponse);
     */
    getListener(input: Empty, options?: RpcOptions): UnaryCall<Empty, GetListenerResponse> {
        const method = this.methods[0], opt = this._transport.mergeOptions(options);
        return stackIntercept<Empty, GetListenerResponse>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: AddListener(proxy.Listener) returns (google.protobuf.Empty);
     */
    addListener(input: Listener, options?: RpcOptions): UnaryCall<Listener, Empty> {
        const method = this.methods[1], opt = this._transport.mergeOptions(options);
        return stackIntercept<Listener, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: RemoveListener(proxy.RemoveListenerRequest) returns (google.protobuf.Empty);
     */
    removeListener(input: RemoveListenerRequest, options?: RpcOptions): UnaryCall<RemoveListenerRequest, Empty> {
        const method = this.methods[2], opt = this._transport.mergeOptions(options);
        return stackIntercept<RemoveListenerRequest, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: AddRouting(proxy.Routing) returns (google.protobuf.Empty);
     */
    addRouting(input: Routing, options?: RpcOptions): UnaryCall<Routing, Empty> {
        const method = this.methods[3], opt = this._transport.mergeOptions(options);
        return stackIntercept<Routing, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: GetRouting(google.protobuf.Empty) returns (proxy.GetRoutingResponse);
     */
    getRouting(input: Empty, options?: RpcOptions): UnaryCall<Empty, GetRoutingResponse> {
        const method = this.methods[4], opt = this._transport.mergeOptions(options);
        return stackIntercept<Empty, GetRoutingResponse>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: GetBackend(google.protobuf.Empty) returns (proxy.GetBackendResponse);
     */
    getBackend(input: Empty, options?: RpcOptions): UnaryCall<Empty, GetBackendResponse> {
        const method = this.methods[5], opt = this._transport.mergeOptions(options);
        return stackIntercept<Empty, GetBackendResponse>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: GetServer(google.protobuf.Empty) returns (proxy.GetServerResponse);
     */
    getServer(input: Empty, options?: RpcOptions): UnaryCall<Empty, GetServerResponse> {
        const method = this.methods[6], opt = this._transport.mergeOptions(options);
        return stackIntercept<Empty, GetServerResponse>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: AddBackend(proxy.Backend) returns (google.protobuf.Empty);
     */
    addBackend(input: Backend, options?: RpcOptions): UnaryCall<Backend, Empty> {
        const method = this.methods[7], opt = this._transport.mergeOptions(options);
        return stackIntercept<Backend, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: RemoveRouting(proxy.RemoveRoutingRequest) returns (google.protobuf.Empty);
     */
    removeRouting(input: RemoveRoutingRequest, options?: RpcOptions): UnaryCall<RemoveRoutingRequest, Empty> {
        const method = this.methods[8], opt = this._transport.mergeOptions(options);
        return stackIntercept<RemoveRoutingRequest, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: RemoveBackend(proxy.RemoveBackendRequest) returns (google.protobuf.Empty);
     */
    removeBackend(input: RemoveBackendRequest, options?: RpcOptions): UnaryCall<RemoveBackendRequest, Empty> {
        const method = this.methods[9], opt = this._transport.mergeOptions(options);
        return stackIntercept<RemoveBackendRequest, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: RemoveServer(proxy.RemoveServerRequest) returns (google.protobuf.Empty);
     */
    removeServer(input: RemoveServerRequest, options?: RpcOptions): UnaryCall<RemoveServerRequest, Empty> {
        const method = this.methods[10], opt = this._transport.mergeOptions(options);
        return stackIntercept<RemoveServerRequest, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: AddServer(proxy.Server) returns (google.protobuf.Empty);
     */
    addServer(input: Server, options?: RpcOptions): UnaryCall<Server, Empty> {
        const method = this.methods[11], opt = this._transport.mergeOptions(options);
        return stackIntercept<Server, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: RemoveAllListener(google.protobuf.Empty) returns (google.protobuf.Empty);
     */
    removeAllListener(input: Empty, options?: RpcOptions): UnaryCall<Empty, Empty> {
        const method = this.methods[12], opt = this._transport.mergeOptions(options);
        return stackIntercept<Empty, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: RemoveAllRouting(google.protobuf.Empty) returns (google.protobuf.Empty);
     */
    removeAllRouting(input: Empty, options?: RpcOptions): UnaryCall<Empty, Empty> {
        const method = this.methods[13], opt = this._transport.mergeOptions(options);
        return stackIntercept<Empty, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: RemoveAllBackend(google.protobuf.Empty) returns (google.protobuf.Empty);
     */
    removeAllBackend(input: Empty, options?: RpcOptions): UnaryCall<Empty, Empty> {
        const method = this.methods[14], opt = this._transport.mergeOptions(options);
        return stackIntercept<Empty, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: RemoveAllServer(google.protobuf.Empty) returns (google.protobuf.Empty);
     */
    removeAllServer(input: Empty, options?: RpcOptions): UnaryCall<Empty, Empty> {
        const method = this.methods[15], opt = this._transport.mergeOptions(options);
        return stackIntercept<Empty, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: SuspendServer(proxy.SuspendServerRequest) returns (google.protobuf.Empty);
     */
    suspendServer(input: SuspendServerRequest, options?: RpcOptions): UnaryCall<SuspendServerRequest, Empty> {
        const method = this.methods[16], opt = this._transport.mergeOptions(options);
        return stackIntercept<SuspendServerRequest, Empty>("unary", this._transport, method, opt, input);
    }
    /**
     * @generated from protobuf rpc: ProxyInfo(google.protobuf.Empty) returns (proxy.ProxyInfoResponse);
     */
    proxyInfo(input: Empty, options?: RpcOptions): UnaryCall<Empty, ProxyInfoResponse> {
        const method = this.methods[17], opt = this._transport.mergeOptions(options);
        return stackIntercept<Empty, ProxyInfoResponse>("unary", this._transport, method, opt, input);
    }
}
/**
 * @generated from protobuf service proxy.Auth
 */
export interface IAuthClient {
    /**
     * @generated from protobuf rpc: ValidateToken(proxy.ValidateTokenRequest) returns (proxy.ValidateTokenResponse);
     */
    validateToken(input: ValidateTokenRequest, options?: RpcOptions): UnaryCall<ValidateTokenRequest, ValidateTokenResponse>;
}
/**
 * @generated from protobuf service proxy.Auth
 */
export class AuthClient implements IAuthClient, ServiceInfo {
    typeName = Auth.typeName;
    methods = Auth.methods;
    options = Auth.options;
    constructor(private readonly _transport: RpcTransport) {
    }
    /**
     * @generated from protobuf rpc: ValidateToken(proxy.ValidateTokenRequest) returns (proxy.ValidateTokenResponse);
     */
    validateToken(input: ValidateTokenRequest, options?: RpcOptions): UnaryCall<ValidateTokenRequest, ValidateTokenResponse> {
        const method = this.methods[0], opt = this._transport.mergeOptions(options);
        return stackIntercept<ValidateTokenRequest, ValidateTokenResponse>("unary", this._transport, method, opt, input);
    }
}
